1200字范文,内容丰富有趣,写作的好帮手!
1200字范文 > arm-linux-ldd如何使用 linux - 交叉编译器ldd - Ubuntu问答

arm-linux-ldd如何使用 linux - 交叉编译器ldd - Ubuntu问答

时间:2020-06-18 17:03:56

相关推荐

arm-linux-ldd如何使用 linux - 交叉编译器ldd - Ubuntu问答

问题描述

我创建了一个交叉编译的arm可执行文件。我想找到可执行文件的库依赖项。我正在使用ubuntu natty并安装了arm-linux-gnueabi工具链,其中不包含ldd。有没有可用的工具来查看Linux中arm可执行文件库的依赖性。

最佳方法

这有点混乱,但这是我能找到的最佳解决方案,并且对于基本使用而言确实非常有效-只需使用其他交叉工具将此脚本另存为”arm-none-linux-gnueabi-ldd”即可。

#!/bin/sh

arm-none-linux-gnueabi-readelf -a $1 | grep "Shared library:"

次佳方法

您也可以使用objdump和,以便仅转储和搜索二进制文件的标头部分。这可以节省您几毫秒的时间…

#!/bin/sh

arm-none-linux-gnueabi-objdump -x $1 | grep NEEDED

第三种方法

这是另一个选项,您可以将LD_TRACE_LOADED_OBJECTS环境变量设置为任何值,例如1,然后您只需运行可执行文件,输出应该是其动态依赖项。

第四种方法

我发现了这一点,并希望它可以为仍在寻找真正的LDD解决方案的许多人提供帮助。 ldd只是一个支持ld-linux库的脚本。那么,为什么不制作自己的ldd脚本呢?首先,您需要在系统中找到ld-linux库,该库应该可用。就我而言,它是/lib/ld-linux-armhf.so.3,因此我将其放入RTLDLIST中,如下面的脚本所示。

并将此脚本放入设备或开发板中,您可以使用ldd,这对于查找可执行文件的依赖库非常方便。

祝好运!

#! /bin/bash

# Copyright (C) 1996-, Free Software Foundation, Inc.

# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or

# modify it under the terms of the GNU Lesser General Public

# License as published by the Free Software Foundation; either

# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,

# but WITHOUT ANY WARRANTY; without even the implied warranty of

# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU

# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public

# License along with the GNU C Library; if not, write to the Free

# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA

# 02111-1307 USA.

# This is the `ldd' command, which lists what shared libraries are

# used by given dynamically-linked executables. It works by invoking the

# run-time dynamic linker as a command and setting the environment

# variable LD_TRACE_LOADED_OBJECTS to a non-empty value.

# We should be able to find the translation right at the beginning.

TEXTDOMAIN=libc

TEXTDOMAINDIR=/usr/share/locale

RTLDLIST="/lib/ld-linux.so.2 /lib64/ld-linux-x86-64.so.2 /lib/ld-linux-armhf.so.3"

warn=

bind_now=

verbose=

while test $# -gt 0; do

case "$1" in

--vers | --versi | --versio | --version)

echo 'ldd (Ubuntu EGLIBC 2.15-0ubuntu10.3) 2.15'

printf $"Copyright (C) %s Free Software Foundation, Inc.

This is free software; see the source for copying conditions. There is NO

warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

" ""

printf $"Written by %s and %s.

" "Roland McGrath" "Ulrich Drepper"

exit 0

;;

--h | --he | --hel | --help)

printf $"Usage: ldd [OPTION]... FILE...

--help print this help and exit

--version print version information and exit

-d, --data-relocs process data relocations

-r, --function-relocs process data and function relocations

-u, --unused print unused direct dependencies

-v, --verbose print all information

"

printf $"For bug reporting instructions, please see:

%s.

" ""

exit 0

;;

-d | --d | --da | --dat | --data | --data- | --data-r | --data-re | \

--data-rel | --data-relo | --data-reloc | --data-relocs)

warn=yes

shift

;;

-r | --f | --fu | --fun | --func | --funct | --functi | --functio | \

--function | --function- | --function-r | --function-re | --function-rel | \

--function-relo | --function-reloc | --function-relocs)

warn=yes

bind_now=yes

shift

;;

-v | --verb | --verbo | --verbos | --verbose)

verbose=yes

shift

;;

-u | --u | --un | --unu | --unus | --unuse | --unused)

unused=yes

shift

;;

--v | --ve | --ver)

echo >&2 $"ldd: option \`$1' is ambiguous"

exit 1

;;

--) # Stop option processing.

shift; break

;;

-*)

echo >&2 'ldd:' $"unrecognized option" "\`$1'"

echo >&2 $"Try \`ldd --help' for more information."

exit 1

;;

*)

break

;;

esac

done

nonelf ()

{

# Maybe extra code for non-ELF binaries.

return 1;

}

add_env="LD_TRACE_LOADED_OBJECTS=1 LD_WARN=$warn LD_BIND_NOW=$bind_now"

add_env="$add_env LD_LIBRARY_VERSION=\$verify_out"

add_env="$add_env LD_VERBOSE=$verbose"

if test "$unused" = yes; then

add_env="$add_env LD_DEBUG=\"$LD_DEBUG${LD_DEBUG:+,}unused\""

fi

# The following use of cat is needed to make ldd work in SELinux

# environments where the executed program might not have permissions

# to write to the console/tty. But only bash 3.x supports the pipefail

# option, and we don't bother to handle the case for older bash versions.

if x=`set -o` && test "$x" != "${x#*pipefail}" && set -o pipefail ; then

try_trace() {

eval $add_env '"$@"' | cat

}

else

try_trace() {

eval $add_env '"$@"'

}

fi

case $# in

0)

echo >&2 'ldd:' $"missing file arguments"

echo >&2 $"Try \`ldd --help' for more information."

exit 1

;;

1)

single_file=t

;;

*)

single_file=f

;;

esac

result=0

for file do

# We don't list the file name when there is only one.

test $single_file = t || echo "${file}:"

case $file in

*/*) :

;;

*) file=./$file

;;

esac

if test ! -e "$file"; then

echo "ldd: ${file}:" $"No such file or directory" >&2

result=1

elif test ! -f "$file"; then

echo "ldd: ${file}:" $"not regular file" >&2

result=1

elif test -r "$file"; then

RTLD=

ret=1

for rtld in ${RTLDLIST}; do

if test -x $rtld; then

verify_out=`${rtld} --verify "$file"`

ret=$?

case $ret in

[02]) RTLD=${rtld}; break;;

esac

fi

done

case $ret in

0|2)

try_trace "$RTLD" "$file" || result=1

;;

1|126)

# This can be a non-ELF binary or no binary at all.

nonelf "$file" || {

echo $" not a dynamic executable"

result=1

}

;;

*)

echo 'ldd:' ${RTLD} $"exited with unknown exit code" "($ret)" >&2

exit 1

;;

esac

else

echo 'ldd:' $"error: you do not have read permission for" "\`$file'" >&2

result=1

fi

done

exit $result

# Local Variables:

# mode:ksh

# End:

参考资料

本内容不代表本网观点和政治立场,如有侵犯你的权益请联系我们处理。
网友评论
网友评论仅供其表达个人看法,并不表明网站立场。